% -------------------------------------------------------------------------
% @ ver 1.0, Sept. 18, 2010, Jonathan P. Fiene, Univ. of Pennsylvania
% -------------------------------------------------------------------------
% Call this routine before disconnecting a Phidget 1061 or 1066 servo board.
% -------------------------------------------------------------------------
% startServo
% -------------------------------------------------------------------------

if exist('Shandle','var')
    valPtr = libpointer('int32Ptr', 0);
    calllib('phidget21', 'CPhidgetAdvancedServo_getMotorCount', Shandle, valPtr);
    motorCount = get(valPtr, 'Value');

    % shut off all servos
    for(i=0:motorCount-1)
        servoPause(i);
    end
    
    % clean up
    calllib('phidget21', 'CPhidget_close', Shandle);
    calllib('phidget21', 'CPhidget_delete', Shandle);

    %unloading the library too quickly causes issues.
    unloadlibrary phidget21;
    clear global Shandle ptr;
    disp('Phidget Servo stop: SUCCESS');
else
    disp('Nothing done - Phidget Servo already stopped (or never started).');
end
